Index: trunk/MagicSoft/Cosy/tpoint/tpoint0612.txt
===================================================================
--- trunk/MagicSoft/Cosy/tpoint/tpoint0612.txt	(revision 8569)
+++ trunk/MagicSoft/Cosy/tpoint/tpoint0612.txt	(revision 8570)
@@ -242,5 +242,5 @@
 
 # 29.12.2006 01:16:01.749
--141.5685 4.800143 0.704412 -3.919526 2.971111 -40.30472 0.1503868 0.252398 54098.052798 3259 5.935
+##-141.5685 4.800143 0.704412 -3.919526 2.971111 -40.30472 0.1503868 0.252398 54098.052798 3259 5.935
 
 # 28.12.2006 23:38:00.888
@@ -312,5 +312,5 @@
 
 # 28.12.2006 23:28:27.055
--125.4655 42.61635 16.6089 33.86769 2.3225 -2.9775 0.1101212 0.4375296 54097.978091 2883 5.853
+##-125.4655 42.61635 16.6089 33.86769 2.3225 -2.9775 0.1101212 0.4375296 54097.978091 2883 5.853
 
 # 28.12.2006 22:38:17.121
@@ -342,5 +342,5 @@
 
 # 29.12.2006 01:00:23.335
--108.033 24.60411 34.04559 15.87793 2.3225 -2.9775 0.1317746 0.4476913 54098.041937 3262 5.904
+##-108.033 24.60411 34.04559 15.87793 2.3225 -2.9775 0.1317746 0.4476913 54098.041937 3262 5.904
 
 # 28.12.2006 22:45:26.866
@@ -406,5 +406,5 @@
 
 # 30.12.2006 02:16:58.682
--18.19473 56.79757 124.0188 48.02164 6.326944 59.01083 0.09009142 0.3008587 54099.095124 3511 5.935
+##-18.19473 56.79757 124.0188 48.02164 6.326944 59.01083 0.09009142 0.3008587 54099.095124 3511 5.935
 
 # 29.12.2006 23:42:29.064
@@ -424,8 +424,8 @@
 
 # 29.12.2006 23:05:34.454
--4.046654 4.811361 138.2641 -3.906712 17.14639 65.71472 0.153189 0.2388854 54098.962204 3365 5.855
+##-4.046654 4.811361 138.2641 -3.906712 17.14639 65.71472 0.153189 0.2388854 54098.962204 3365 5.855
 
 # 30.12.2006 01:51:56.074
-16.23395 18.23559 158.7958 9.341903 15.34556 71.83389 0.0646912 -0.01182471 54099.077732 3394 2.791
+##16.23395 18.23559 158.7958 9.341903 15.34556 71.83389 0.0646912 -0.01182471 54099.077732 3394 2.791
 
 # 29.12.2006 21:25:13.742
@@ -460,5 +460,5 @@
 
 # 30.12.2006 01:46:35.055
-15.33216 21.02686 157.89 12.14675 14.845 74.15556 0.07631375 -0.008520981 54099.074017 3383 1.632
+##15.33216 21.02686 157.89 12.14675 14.845 74.15556 0.07631375 -0.008520981 54099.074017 3383 1.632
 
 # 29.12.2006 21:07:16.079
@@ -469,11 +469,11 @@
 
 # 30.12.2006 01:59:24.860
-6.285041 35.73052 148.5694 26.89704 9.618056 81.32639 0.12145 0.2585308 54099.082927 3432 5.841
+##6.285041 35.73052 148.5694 26.89704 9.618056 81.32639 0.12145 0.2585308 54099.082927 3432 5.841
 
 # 30.12.2006 02:05:28.641
-11.11674 21.37945 153.4199 12.56057 15.73417 77.79444 0.1393184 0.2450556 54099.087137 3531 5.904
+##11.11674 21.37945 153.4199 12.56057 15.73417 77.79444 0.1393184 0.2450556 54099.087137 3531 5.904
 
 # 29.12.2006 23:12:35.959
--3.328887 4.709089 138.9826 -4.010102 17.14639 65.71472 0.1524416 0.2372941 54098.967083 3374 5.96
+##-3.328887 4.709089 138.9826 -4.010102 17.14639 65.71472 0.1524416 0.2372941 54098.967083 3374 5.96
 
 # 29.12.2006 22:16:34.842
@@ -525,5 +525,5 @@
 
 # 30.12.2006 00:50:43.221
-161.99 29.39587 304.5242 20.50979 7.401667 -29.30306 0.06842851 -0.008484257 54099.035222 3392 2
+##161.99 29.39587 304.5242 20.50979 7.401667 -29.30306 0.06842851 -0.008484257 54099.035222 3392 2
 
 # 29.12.2006 23:57:53.398
@@ -540,5 +540,5 @@
 
 # 29.12.2006 23:07:56.542
--3.806345 4.775042 138.5066 -3.954898 17.14639 65.71472 0.1526661 0.2370098 54098.963849 3375 5.972
+##-3.806345 4.775042 138.5066 -3.954898 17.14639 65.71472 0.1526661 0.2370098 54098.963849 3375 5.972
 
 # 29.12.2006 20:30:14.110
@@ -549,5 +549,5 @@
 
 # 30.12.2006 01:29:15.155
-23.8208 33.62482 166.1263 24.79092 11.52333 69.33111 0.1218493 0.2388895 54099.061981 3220 5.904
+##23.8208 33.62482 166.1263 24.79092 11.52333 69.33111 0.1218493 0.2388895 54099.061981 3220 5.904
 
 # 29.12.2006 22:36:16.111
@@ -555,5 +555,5 @@
 
 # 30.12.2006 01:35:15.336
-23.38863 28.73226 165.6983 19.90551 12.55806 69.78833 0.1291973 0.2365786 54099.06615 3253 5.967
+##23.38863 28.73226 165.6983 19.90551 12.55806 69.78833 0.1291973 0.2365786 54099.06615 3253 5.967
 
 # 29.12.2006 21:09:00.326
@@ -561,5 +561,5 @@
 
 # 30.12.2006 00:08:04.074
-44.99382 39.85836 187.5405 30.98464 9.5475 51.67722 0.08481177 -0.007322661 54099.005603 3381 2.785
+##44.99382 39.85836 187.5405 30.98464 9.5475 51.67722 0.08481177 -0.007322661 54099.005603 3381 2.785
 
 # 30.12.2006 02:44:54.539
@@ -576,5 +576,5 @@
 
 # 30.12.2006 01:48:59.864
-14.99782 23.16515 157.3051 14.3419 14.45861 75.69611 0.1349053 0.2408761 54099.075693 3383 5.963
+##14.99782 23.16515 157.3051 14.3419 14.45861 75.69611 0.1349053 0.2408761 54099.075693 3383 5.963
 
 # 29.12.2006 20:56:55.443
@@ -610,5 +610,5 @@
 
 # 30.12.2006 01:23:57.816
-26.20746 46.48483 168.5002 37.631 9.525556 63.06194 0.1034313 0.2401603 54099.058308 3398 5.83
+##26.20746 46.48483 168.5002 37.631 9.525556 63.06194 0.1034313 0.2401603 54099.058308 3398 5.83
 
 # 29.12.2006 22:56:15.061
@@ -635,5 +635,5 @@
 
 # 30.12.2006 02:08:55.373
-14.22599 8.288777 156.5394 -0.5280937 17.14639 65.71472 0.1492202 0.2378438 54099.08953 3454 5.918
+##14.22599 8.288777 156.5394 -0.5280937 17.14639 65.71472 0.1492202 0.2378438 54099.08953 3454 5.918
 
 # 29.12.2006 21:16:52.713
@@ -707,5 +707,5 @@
 
 # 31.12.2006 00:16:20.540
-84.03424 62.77611 226.5389 53.87166 7.755278 28.02611 0.06440748 -0.009608853 54100.011349 3865 1.227
+##84.03424 62.77611 226.5389 53.87166 7.755278 28.02611 0.06440748 -0.009608853 54100.011349 3865 1.227
 
 # 30.12.2006 21:29:33.029
@@ -737,5 +737,5 @@
 
 # 30.12.2006 21:10:36.366
-134.618 31.03618 277.159 22.16073 5.215556 -16.20556 0.08030475 -0.01345093 54099.882365 4039 3.245
+##134.618 31.03618 277.159 22.16073 5.215556 -16.20556 0.08030475 -0.01345093 54099.882365 4039 3.245
 
 # 31.12.2006 01:50:35.785
@@ -746,5 +746,5 @@
 
 # 30.12.2006 21:04:52.707
-116.4952 50.355 259.0236 41.46192 4.830556 6.961389 0.06866954 -0.01524895 54099.878388 3985 3.004
+##116.4952 50.355 259.0236 41.46192 4.830556 6.961389 0.06866954 -0.01524895 54099.878388 3985 3.004
 116.6109 50.51055 259.1432 41.56078 4.830556 6.961389 0.01279495 -0.02115717 54099.87874 4326 2.97
 
@@ -762,5 +762,5 @@
 
 # 31.12.2006 02:29:06.441
-28.42678 24.68175 170.9939 15.78397 14.07306 64.37583 0.05975852 -0.01923022 54100.103547 3390 3.805
+##28.42678 24.68175 170.9939 15.78397 14.07306 64.37583 0.05975852 -0.01923022 54100.103547 3390 3.805
 
 # 31.12.2006 03:25:16.118
@@ -813,5 +813,5 @@
 
 # 30.12.2006 23:49:23.684
-31.20196 11.101 173.7619 2.18497 12.90056 55.95972 0.04724415 -0.006270268 54099.992635 3525 2.136
+##31.20196 11.101 173.7619 2.18497 12.90056 55.95972 0.04724415 -0.006270268 54099.992635 3525 2.136
 
 # 30.12.2006 23:18:02.613
@@ -859,5 +859,5 @@
 
 # 30.12.2006 20:48:25.450
-80.94805 33.89582 223.5015 25.00744 6.382778 22.51361 0.06727998 -0.01578572 54099.866961 3997 2.107
+##80.94805 33.89582 223.5015 25.00744 6.382778 22.51361 0.06727998 -0.01578572 54099.866961 3997 2.107
 
 # 31.12.2006 02:43:06.372
@@ -901,5 +901,5 @@
 
 # 30.12.2006 23:44:56.548
-8.468631 12.36002 151.0249 3.472784 15.34556 71.83389 0.07479178 -0.004602198 54099.989543 3523 3.266
+##8.468631 12.36002 151.0249 3.472784 15.34556 71.83389 0.07479178 -0.004602198 54099.989543 3523 3.266
 
 # 30.12.2006 21:08:21.118
@@ -976,5 +976,5 @@
 
 # 31.12.2006 02:14:45.710
-30.34295 43.25212 172.8853 34.36352 11.06222 61.75083 0.06837406 -0.005220536 54100.093585 3406 1.621
+##30.34295 43.25212 172.8853 34.36352 11.06222 61.75083 0.06837406 -0.005220536 54100.093585 3406 1.621
 
 # 30.12.2006 20:31:54.912