Index: trunk/Dwarf/Documents/ApplicationDFG/application.tex
===================================================================
--- trunk/Dwarf/Documents/ApplicationDFG/application.tex	(revision 8610)
+++ trunk/Dwarf/Documents/ApplicationDFG/application.tex	(revision 8613)
@@ -3,6 +3,6 @@
 \usepackage[round]{natbib}
 
-\renewcommand{\familydefault}{\sfdefault}
-\usepackage{helvet}
+%\renewcommand{\familydefault}{\sfdefault}
+%\usepackage{helvet}
 
 \setlength{\parindent}{0pt}
@@ -140,40 +140,16 @@
 % AUCH IN DEUTSCH BEIFGEN
 We propose to set up an imaging air Cherenkov telescope with low-cost
-but high performance design for robotic operation. The goal is to
-achieve long-term monitoring of bright blazars which will unravel the
-origin and nature of their variability (und den zugrunde liegen
-Beschleunigungsmachanismen). The telescope design is based on a
-technological upgrade of one of the former telescopes of the HEGRA
-collaboration still located at the Observatorio Roque de los Muchachos
-on the Canarian Island La Palma (Spain).  With the upgrade an
-improvement in senitivity by xx\% and a xx\% lower energy threshold
-will be achieved.
-
+but high performance design for robotic and remote operation. The goal
+is to achieve long-term monitoring of bright blazars which will unravel
+the origin and nature of their variability (und den zugrunde liegen
+Beschleunigungsmachanismen der kosmischen Strahlung). The telescope
+design is based on a technological upgrade of one of the former
+telescopes of the HEGRA collaboration still located at the Observatorio
+Roque de los Muchachos on the Canarian Island La Palma (Spain). With
+the upgrade an improvement in senitivity by 25\%{\bf (?)} and a lower
+energy threshold in the order of 350\,GeV{\bf (?)} will be achieved.
+
+{\bf IceCube erw"ahnen?}
 {\em Nicht gescheduled von anderen IACTs?}
-
-%Beantragt \citeauthor{Chandrasekhar:1931} wird die F"orderung eines
-%Luft-Cherenkov-Teleskops f"ur Langzeitbeobachtungen von Gamma-Quellen
-%im Energiebereich zwischen 500 GeV und 50 TeV (DWARF=Dedicated
-%multiWavelength Astroparticle Research Facility). Mit DWARF sollen zwei
-%Aufgaben bei der Beobachtung erf"ullt werden:
-
-%1. weitgehend
-%automatisierte Langzeitbeobachtungen von bekannten hochenergetischen
-%Quellen. Solche Beobachtungen stehen nicht auf dem Programm der im
-%Betrieb befindlichen Generation von Cherenkov-Teleskopen 2.
-%Multiwavelenght-Kampangen mit Photon-Detektoren in unterschiedlichen
-%Energiebreichen, insbesondere auch mit dem Neutrino-Teleskop IceCube.
-%F"ur den Aufbau von DWARF soll die bestehende Infrastruktur auf dem
-%Roque de los Muchachos auf der kanarischen Insel La Palma genutzt
-%werden.  Dort befindet sich der zur Zeit ungenutzte Mount des
-%ehemaligen ``HEGRA-Cherenkov-Teleskops 3'' sowie eine zur Plazierung
-%der Elektronik geeignete H"utte samt elektrischer Versorgung bei dem
-%Teleskop. Zur Minimierung von Peronalkosten soll das Teleskop nach der
-%Aufbauphase weitestgehend robotisch "uber das Internet / einen Link
-%"uber den ESA-Satelltien XYZ betrieben werden. Die mit DWARF
-%vorgenommenen Messungen dienen der Kl"arung der Frage nach der
-%zeitlichen Variabilit"at der Gamma-Emissionen von Aktiven Galaxien und
-%den zugrundeliegenden Beschelunigungsmechanismen der kosmsichen
-%Strahlung.\\
 
 {\em
@@ -198,8 +174,10 @@
 \item Knapp und pr"azise in der unmittelbaren Beziehung zum Vorhaben
 \item Als Begr"undung f"ur eigene Arbeit
-\item incl. einschl"agiger Arbeiten anderer Wissenschaftler
+\item inkl. einschl"agiger Arbeiten anderer Wissenschaftler
 \item $\to$ Einordnung eigener Arbeit, welcher Beitrag zu welchen Fragen
 \end{itemize}
 }
+
+{\bf Hier gibt es glaub ich drei Punkte: Physik, IACTs und gAPD}
 
 \paragraph{Introduction:} Since the termination of the HEGRA
@@ -208,5 +186,5 @@
 detecting tens of formerly unknown gamma ray sources and analyzing
 their energy spectra and temporal behavior. This became possible by
-lowering the energy threshold from 700 GeV to less than 100 GeV and
+lowering the energy threshold from 700\,GeV to less than 100\,GeV and
 increasing at the same time the sensitivity by a factor of five.
 
@@ -237,8 +215,9 @@
 a solid and complete data base for variability investigations. 
 
-{\bf Hier sollte ganz klar rauskommen warum man unbedingt ein 
+{\bf Hier sollte ganz klar rauskommen was der aktuelle Stand der
+Forschung ist und wieso man um weiter zu kommen unbedingt ein 
 long-term monitoring IACT braucht}
 
-{\bf Geigermde APDs?}
+{\bf Geigermode APDs?}
 
 \subsubsection{High energy gamma and neutrino sources}
@@ -251,12 +230,11 @@
 decades. Additionally there are two diffuse regions within our galaxy
 which have been detected by H.E.S.S.\cite{Aharonian:2006} and Milagro
-{\bf ZITAT!!! } {\it Neues Millagro Papier mit "TeV Gamma-Ray Sources
-from a Survex of the Galactic Plane with Milagro} 4+ Quellregionen:
-"TeV Gamma-Ray Sources from a Survey of the Galactic  Plane with
-Milagro" Arxiv-Nr.: 0705.0707 The first source was discovered in the
-year 19{\bf??} by the {\bf HEGRA} collaboration {\it (War das nicht wer
-anders, die zu allererst den Crab sahen?...ZITAT?)}. In comparison to
+\cite{Milagro:2007}.
+%The first source was discovered in the
+%year 19{\bf??} by the {\bf HEGRA} collaboration {\it (War das nicht wer
+%anders, die zu allererst den Crab sahen?...ZITAT?)}.
+In comparison to
 x-ray measurments, which are able to scan the entire sky for sources
-and thus have  cataloged more than {\bf 1000 ???} sources, this number
+and thus have cataloged more than {\bf 1000 ???} sources, this number
 appears to be quite small. One reason for this is the small field of
 view of imaging air cherenkov telesopes (IACTs), another reason the
@@ -264,31 +242,40 @@
 extragalactic background light (EBL). Due to this small statistic at
 the moment it is of particular importance that instruments with high
-sensitivity concentrate on the analysis of new objects in the TeV sky
+sensitivity concentrate on the observation of new objects in the TeV sky
 and not on the quantitative, permanent observation of already known
-sources. Even when a source was observed over a longer period of time
-this does mean {\bf  less than three month ???? {\it Viel l"anger sind
-die Quellen am St"uck doch gar nicht sichtbar, oder? Sinnvoller w"are
-es wom"oglich die wenigen Beobachtungsstunden in diesen X Monaten
-hervorzuheben.}} But one has to take into account that during this time
-also periods of bad weather and times with strong moon light can
-significantly reduce  observation time. Furthermore one has to consider
-that the sources are visible in the sky only for a few hours each night.
+sources. 
+% BRAUCHT MAN DEN FOLGENDEN ABSATZ WIRKLICH
+%Even when a source was observed over a longer period of time
+%this does mean {\bf  less than three month ???? {\it Viel l"anger sind
+%die Quellen am St"uck doch gar nicht sichtbar, oder? Sinnvoller w"are
+%es wom"oglich die wenigen Beobachtungsstunden in diesen X Monaten
+%hervorzuheben.}} But one has to take into account that during this time
+%also periods of bad weather and times with strong moon light can
+%significantly reduce  observation time. Furthermore one has to consider
+%that the sources are visible in the sky only for a few hours each night.
+
+%{\bf Ist die Aufz"ahlung nich total "ubertrieben? Ist es f"ur unseren
+%Antrag wirklich interessant welchem Typ die detektierten AGN angeh"oren
+%und  wie sie hei"sen?}
 
 The so far observed galactic objects are microqasars and supernova
 remnands (SNR). The identified extragalactic sources are active
-galactic nuclei (AGN). The objects are listed in table~\ref{dummy} {\bf
-TESHIMAS VORTRAG IN MADISON}. The AGN are 13 BLLacs and one FR-I
+galactic nuclei (AGN). 
+%NOETIG??? The objects are listed in table~\ref{dummy} {\bf
+%TESHIMAS VORTRAG IN MADISON}. 
+The AGN are 13 BLLacs and one FR-I
 galaxy, M87. So High-peaked BL Lacertae objects are the prime source
-population for studies with Cherenkov telescopes.  It is obvious that
+population for studies with Cherenkov telescopes. It is obvious that
 monitoring observations of strong blazars are orthogonal to the mission
 of the larger Cherenkov telescopes with their discovery potential for
 new sources (luminosity function, redshift distribution).
+{\bf Das hatten wir oben eigtnlich schonmal}
 
 In case of hadronic particle acceleration within the TeV emitters, the
-TeV signal may arise from $\pi^0$-decays. These neutral pions are decay
-products of of delta resonances, which are formed in proton-photon
-interactions. Anther decay channel of the delta resonance leads to the
+signal may arise from $\pi^0$-decays. These neutral pions are decay
+products of delta resonances, which are formed in proton-photon
+interactions. Another decay channel of the delta resonance leads to the
 production of charged pions and thus to neutrino production, coincident
-with the TeV photons mentioned before. Therefrom TeV sources are always
+with the TeV photons. Therefrom TeV sources are always
 interesting objects for investigations with high energy neutrino
 telescopes.
@@ -453,7 +440,6 @@
 expected from galaxy merger models.\\ \textbf{the search for signatures of
 binary black hole systems from orbital modulation of VHE gamma ray
-emission}\\
-\textbf{\item Rieger, Mannheim; Implications of a possible 23 day periodocit for binary black hole  models in Mkn 501
-\item Rieger, Mannheim; A possible black hole binary in Mkn 501
+emission} \cite{Rieger:2000, Rieger:2001}\\
+\item {\bf Wird das nicht ein bisschen viel Rieger?
 \item Rieger; Periodic variability and binary black hole systems in blazars
 \item Rieger; Supermassive binary black holes among cosmic gamma-ray sources
@@ -518,10 +504,11 @@
 studied with hybrid MHD and particle-in-cell methods.
 
-\item {The black hole mass and accretion rate will be determined from
+\item The black hole mass and accretion rate will be determined from
 the emission models. Estimates of the black hole mass from emission
 models, a possible orbital modulation, and the Magorrian relation
 (relating the black hole mass with the stellar bulge mass of the host
-galaxy) will be compared.
-\textbf{\item Rieger, Mannheim; On the central black hole mass in Mkn 501}}
+galaxy) will be compared. \cite{Rieger:2003} {\bf eigentlich ist das
+nicht mehr die Stelle mit Zitaten sondern die wo wir sagen, dass
+wir das Know-how - in Form von Frank - haben.}
 
 \item \textbf{To achieve a maximal database for these studies the
@@ -629,5 +616,5 @@
 single pixel will be in the order of 600 EURO.
 
-If development of G-APDs (QE$\ge$50$\%$) will be fast enough,
+If development of geigermode APDs (QE$\ge$50$\%$) will be fast enough,
 respectively the price low enough, and their long term stability is
 proven well in time, their usage will be considered.
@@ -636,7 +623,7 @@
 (see figure \ref{camCT3}). With a special coating (wavelength shifter)
 its quantum efficiency might be improved by ~8$\%$\cite{Paneque:2004}.
-\textbf{8\% sind für flat-window-pmts angegeben...nach den Zeichnungen 
-in z.B. German Hermanns Diss. sind sie aber nicht völlig flach...demnach 
-könnten wir wohl 19\% zitieren.}
+\textbf{8\% sind f"ur flat-window-pmts angegeben... nach den Zeichnungen 
+in z.B. German Hermanns Diss. sind sie aber nicht v"ollig flach...demnach 
+k"onnten wir wohl 19\% zitieren.}
 \textbf{Figure?}
 
@@ -655,5 +642,5 @@
 CT3 system.
 
-For this setup the camera holding has to be redesigned. (1500EURO?)
+For this setup the camera holding has to be redesigned. (1500\,Eur?)
 
 An electric and optical shielding of the individual PMs is planned.
@@ -692,13 +679,13 @@
 and processed by the W"urzburg Datacenter (current online capacity
 $>$20\,TB, offline capacity $>$30\,TB, $>$16\,CPUs). To archive the data
-safely 25 tapes (LTO3 with 400\,GB each, $\sim$1000\,EURO) and a SATA
-disk-array ($\sim$4000EURO) will be bought.
+safely 25 tapes (LTO3 with 400\,GB each, $\sim$1000\,Eur) and a SATA
+disk-array ($\sim$4000\,Eur) will be bought.
 
 \paragraph{On-site computing:}
 For on-site computing less than three standard PCs are needed
-($\sim$8.000EURO). This includes readout and storage, preprocessing,
+($\sim$8.000\,Eur). This includes readout and storage, preprocessing,
 and telescope control. For safety reasons a firewall is mandatory. For
 local storage and backup two RAID\,5 SATA disk arrays with less than one
-Terabyte capacity each will fulfill the requirement ($\sim$4.000EURO).
+Terabyte capacity each will fulfill the requirement ($\sim$4.000\,Eur).
 The data will be transmitted as soon as possible after data taking via
 Internet to the W"urzburg Datacenter.
@@ -730,5 +717,5 @@
 An uninterruptible power-supply unit (UPS) with 5-10\,kW will be
 installed to protect the equipment against power cuts and ensure a safe
-telescope position at the time of sun-rise. ($<$2000EURO)
+telescope position at the time of sun-rise. ($<$2000\,Eur)
 
 \paragraph{Mirrors:}
@@ -748,5 +735,5 @@
 the old glass mirrors (8.5\,m$^2$) is possible with high purity aluminum
 and quartz coating. (Both cases: 30 mirrors, 10k, offer by L-Tec
-$\lesssim$500 EURO / mirror *30 mirrors = 15.000 EURO without transfer)
+$\lesssim$500\,Eur/mirror * 30\,mirrors = 15.000\,Eur without transfer)
 
 \textbf{In both cases the mirrors can be coated with the same high 
@@ -764,7 +751,7 @@
 For a 3.5\,m \textbf{4\,m} diameter mirror the delay between an isochronous parabolic
 mirror and a spherical mirror at the edge is in the order of\textbf{well below} 1ns (see
-figure/appendix). For a sampling rate in the order of 1\,GHz a mirror
-mounting with a parabolic shape is \textbf{not} needed. Since their small size the
-individual mirrors can still\textbf{also} have a spherical shape.
+figure/appendix). For a sampling rate in the order of 2\,GHz a mirror
+mounting with a parabolic shape is not needed. Since their small size the
+individual mirrors can have a spherical shape.
 
 \paragraph{Telescope calibration:}
@@ -776,16 +763,16 @@
 guide stars on the camera surface and ensures a pointing accuracy well
 below the pixel diameter. Therefore a high sensitive low-cost video
-camera, as already in operation for MAGIC I and II, (300 EURO camera,
-300 EURO optics, 300 EURO housing) will be installed.
+camera, as already in operation for MAGIC I and II, (300\,Eur camera,
+300\,Eur optics, 300\,Eur housing) will be installed.
 
 PM Gain: For the calibration of the PM gain a calibration system as
-used for the MAGIC telescope is build. (2.000 EURO)
+used for the MAGIC telescope is build. (2.000\,Eur)
 
 Summarizing, the expenses for the telescope are dominated by the camera
 and DAQ. The financial volume for the complete hardware inclusive
-transport amounts roughly 400.000 EURO.  
+transport amounts roughly 400.000\,Eur.
 
 \textbf{Future extensions:} The known duty cycle of 10\%
-($\sim$1000h/year) for a Cherenkov telescope operated at La Palma
+($\sim$1000\,h/year) for a Cherenkov telescope operated at La Palma
 limits the time-coverage of the observations. Therefore we propose a
 worldwide network of ($<$10) small scale Cherenkov telescopes to be
@@ -799,5 +786,5 @@
 telescope, also builds by MERO, and has a diameter in the order of
 eight meters. Including support (concrete foundation, railways, etc)
-the costs are below 100.000EURO
+the costs are below 100.000\,Eur.
 \textbf{The intended future use of a camera built of G-APDs will by their 
 highly improved QE (50\% instead of 20\%) increase the sensitivity by a factor 
@@ -1256,19 +1243,11 @@
 %\section{References}
 
-%\bibliographystyle{alpha}
 \newpage
 %(Referenzen aus unseren Gruppen sind mit einem Stern gekennzeichnet *)
 (References of our groups are marked by an asterix *)
 \bibliography{application}
-%This in the bibtex style, is ok.
-\bibliographystyle{plain}
-References will be added in the final version.
-%\begin{thebibliography}{99}
-%\bibitem{andreas_05} *M.~Ackermann et al., ''On the selection of AGN neutrino
-%    source candidates $\ldots$'', submitted to {\app} 
-
-
-%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-%\end{thebibliography}
+\bibliographystyle{plainnat}
+%\bibliographystyle{alpha}
+%\bibliographystyle{plain}
 
 \end{document}