Index: trunk/MagicSoft/Mars/mhflux/MAlphaFitter.cc
===================================================================
--- trunk/MagicSoft/Mars/mhflux/MAlphaFitter.cc	(revision 8680)
+++ trunk/MagicSoft/Mars/mhflux/MAlphaFitter.cc	(revision 8695)
@@ -526,5 +526,5 @@
 {
     const TString name(Form("TempAlphaEnergy%06d", gRandom->Integer(1000000)));
-    TH1D *h = hon.ProjectionZ(name, -1, 9999, bin, bin, "E");
+    TH1D *h = hon.ProjectionZ(name, -1, -1, bin, bin, "E");
     h->SetDirectory(0);
 
@@ -537,5 +537,5 @@
 {
     const TString name(Form("TempAlphaTheta%06d", gRandom->Integer(1000000)));
-    TH1D *h = hon.ProjectionZ(name, bin, bin, -1, 9999, "E");
+    TH1D *h = hon.ProjectionZ(name, bin, bin, -1, -1, "E");
     h->SetDirectory(0);
 
@@ -551,5 +551,5 @@
     hon.GetZaxis()->SetRange(bin,bin);
     TH1D *h = (TH1D*)hon.Project3D("ye");
-    hon.GetZaxis()->SetRange(-1,9999);
+    hon.GetZaxis()->SetRange(-1,-1);
 
     h->SetDirectory(0);
@@ -563,5 +563,5 @@
 {
     const TString name(Form("TempAlpha%06d", gRandom->Integer(1000000)));
-    TH1D *h = hon.ProjectionZ(name, -1, 9999, -1, 9999, "E");
+    TH1D *h = hon.ProjectionZ(name, -1, -1, -1, -1, "E");
     h->SetDirectory(0);
 
@@ -576,6 +576,6 @@
     const TString name0(Form("TempAlpha%06d_off", gRandom->Integer(1000000)));
 
-    TH1D *h1 = hon.ProjectionZ(name1, -1, 9999, bin, bin, "E");
-    TH1D *h0 = hof.ProjectionZ(name0, -1, 9999, bin, bin, "E");
+    TH1D *h1 = hon.ProjectionZ(name1, -1, -1, bin, bin, "E");
+    TH1D *h0 = hof.ProjectionZ(name0, -1, -1, bin, bin, "E");
     h1->SetDirectory(0);
     h0->SetDirectory(0);
@@ -594,6 +594,6 @@
     const TString name0(Form("TempAlpha%06d_off", gRandom->Integer(1000000)));
 
-    TH1D *h1 = hon.ProjectionZ(name1, bin, bin, -1, 9999, "E");
-    TH1D *h0 = hof.ProjectionZ(name0, bin, bin, -1, 9999, "E");
+    TH1D *h1 = hon.ProjectionZ(name1, bin, bin, -1, -1, "E");
+    TH1D *h0 = hof.ProjectionZ(name0, bin, bin, -1, -1, "E");
     h1->SetDirectory(0);
     h0->SetDirectory(0);
@@ -614,10 +614,10 @@
     hon.GetZaxis()->SetRange(bin,bin);
     TH1D *h1 = (TH1D*)hon.Project3D("ye");
-    hon.GetZaxis()->SetRange(-1,9999);
+    hon.GetZaxis()->SetRange(-1,-1);
     h1->SetDirectory(0);
 
     hof.GetZaxis()->SetRange(bin,bin);
     TH1D *h0 = (TH1D*)hof.Project3D("ye");
-    hof.GetZaxis()->SetRange(-1,9999);
+    hof.GetZaxis()->SetRange(-1,-1);
     h0->SetDirectory(0);
 
@@ -635,6 +635,6 @@
     const TString name0(Form("TempAlpha%06d_off", gRandom->Integer(1000000)));
 
-    TH1D *h1 = hon.ProjectionZ(name1, -1, 9999, -1, 9999, "E");
-    TH1D *h0 = hof.ProjectionZ(name0, -1, 9999, -1, 9999, "E");
+    TH1D *h1 = hon.ProjectionZ(name1, -1, -1, -1, -1, "E");
+    TH1D *h0 = hof.ProjectionZ(name0, -1, -1, -1, -1, "E");
     h1->SetDirectory(0);
     h0->SetDirectory(0);
Index: trunk/MagicSoft/Mars/mhflux/MHAlpha.cc
===================================================================
--- trunk/MagicSoft/Mars/mhflux/MHAlpha.cc	(revision 8680)
+++ trunk/MagicSoft/Mars/mhflux/MHAlpha.cc	(revision 8695)
@@ -401,5 +401,5 @@
     MAlphaFitter fit(fFit);
 
-    TH1D *h = fOffData ? fOffData->ProjectionZ("ProjTimeTemp", -1, 9999, -1, 9999, "E") : 0;
+    TH1D *h = fOffData ? fOffData->ProjectionZ("ProjTimeTemp", -1, -1, -1, -1, "E") : 0;
     const Bool_t rc = fit.ScaleAndFit(fHistTime, h);
     if (h)
Index: trunk/MagicSoft/Mars/mhflux/MHCollectionArea.cc
===================================================================
--- trunk/MagicSoft/Mars/mhflux/MHCollectionArea.cc	(revision 8680)
+++ trunk/MagicSoft/Mars/mhflux/MHCollectionArea.cc	(revision 8695)
@@ -121,6 +121,6 @@
 void MHCollectionArea::CalcEfficiency()
 {
-    TH1D *hsel = fHistSel.ProjectionY("Spy", -1, 9999, "E");;
-    TH1D *hall = fHistAll.ProjectionY("Apy", -1, 9999, "E");
+    TH1D *hsel = fHistSel.ProjectionY("Spy", -1, -1, "E");;
+    TH1D *hall = fHistAll.ProjectionY("Apy", -1, -1, "E");
 
     //
@@ -327,11 +327,11 @@
     pad->cd(1);
     if (gPad->FindObject("ProjSelX"))
-        fHistSel.ProjectionX("ProjSelX", -1, 9999, "E");
+        fHistSel.ProjectionX("ProjSelX", -1, -1, "E");
 
     pad->cd(2);
     if (gPad->FindObject("ProjAllY"))
-        h1=fHistAll.ProjectionY("ProjAllY", -1, 9999, "E");
+        h1=fHistAll.ProjectionY("ProjAllY", -1, -1, "E");
     if (gPad->FindObject("ProjSelY"))
-        h2=fHistSel.ProjectionY("ProjSelY", -1, 9999, "E");
+        h2=fHistSel.ProjectionY("ProjSelY", -1, -1, "E");
 
     if (h1 && h1->GetMaximum()>0)
@@ -381,5 +381,5 @@
         gPad->SetGridy();
         /*
-        h = fHistAll.ProjectionX("ProjAllX", -1, 9999, "E");
+        h = fHistAll.ProjectionX("ProjAllX", -1, -1, "E");
         h->SetXTitle("\\Theta [\\circ]");
         h->SetDirectory(NULL);
@@ -388,5 +388,5 @@
         h->Draw();
         */
-        h = fHistSel.ProjectionX("ProjSelX", -1, 9999, "E");
+        h = fHistSel.ProjectionX("ProjSelX", -1, -1, "E");
         h->SetXTitle("\\Theta [\\circ]");
         h->SetDirectory(NULL);
@@ -405,5 +405,5 @@
         gPad->SetGridy();
 
-        h1 = fHistAll.ProjectionY("ProjAllY", -1, 9999, "E");
+        h1 = fHistAll.ProjectionY("ProjAllY", -1, -1, "E");
         h1->SetDirectory(NULL);
         h1->SetLineColor(kGreen);
@@ -412,5 +412,5 @@
         h1->Draw();
 
-        h2 = fHistSel.ProjectionY("ProjSelY", -1, 9999, "E");
+        h2 = fHistSel.ProjectionY("ProjSelY", -1, -1, "E");
         h2->SetDirectory(NULL);
         h2->SetLineColor(kRed);
Index: trunk/MagicSoft/Mars/mhflux/MHEffectiveOnTime.cc
===================================================================
--- trunk/MagicSoft/Mars/mhflux/MHEffectiveOnTime.cc	(revision 8680)
+++ trunk/MagicSoft/Mars/mhflux/MHEffectiveOnTime.cc	(revision 8695)
@@ -866,5 +866,5 @@
         if ((h = (TH1D*)gPad->FindObject("ProjDeltaT"/*fNameProjDeltaT*/)))
         {
-            h = fH2DeltaT.ProjectionX("ProjDeltaT"/*fNameProjDeltaT*/, -1, 9999, "E");
+            h = fH2DeltaT.ProjectionX("ProjDeltaT"/*fNameProjDeltaT*/, -1, -1, "E");
             if (h->GetEntries()>0)
                 gPad->SetLogy();
@@ -873,5 +873,5 @@
         pad->GetPad(2)->cd(1);
         if ((h = (TH1D*)gPad->FindObject("ProjTheta"/*fNameProjTheta*/)))
-            fH2DeltaT.ProjectionY("ProjTheta"/*fNameProjTheta*/, -1, 9999, "E");
+            fH2DeltaT.ProjectionY("ProjTheta"/*fNameProjTheta*/, -1, -1, "E");
 
         if (!fIsFinalized)
@@ -963,5 +963,5 @@
     pad->GetPad(1)->cd(1);
     gPad->SetBorderMode(0);
-    h = fH2DeltaT.ProjectionX("ProjDeltaT"/*fNameProjDeltaT*/, -1, 9999, "E");
+    h = fH2DeltaT.ProjectionX("ProjDeltaT"/*fNameProjDeltaT*/, -1, -1, "E");
     h->SetTitle("Distribution of \\Delta t [s]");
     h->SetXTitle("\\Delta t [s]");
@@ -993,5 +993,5 @@
     pad->GetPad(2)->cd(1);
     gPad->SetBorderMode(0);
-    h = fH2DeltaT.ProjectionY("ProjTheta"/*fNameProjTheta*/, -1, 9999, "E");
+    h = fH2DeltaT.ProjectionY("ProjTheta"/*fNameProjTheta*/, -1, -1, "E");
     h->SetTitle("Distribution of  \\Theta [\\circ]");
     h->SetXTitle("\\Theta [\\circ]");
Index: trunk/MagicSoft/Mars/mhflux/MHEnergyEst.cc
===================================================================
--- trunk/MagicSoft/Mars/mhflux/MHEnergyEst.cc	(revision 8680)
+++ trunk/MagicSoft/Mars/mhflux/MHEnergyEst.cc	(revision 8695)
@@ -364,5 +364,5 @@
     if ((hx=(TH1D*)gPad->FindObject(MString::Format("Prof%s", h.GetName()))))
     {
-        hx = hyx->ProfileX(Form("Prof%s", h.GetName()), -1, 9999, "s");
+        hx = hyx->ProfileX(Form("Prof%s", h.GetName()), -1, -1, "s");
 
         if (logy && hx->GetMaximum()>0)
@@ -387,5 +387,5 @@
     h2->SetLineColor(kRed);
 
-    TH1D *h1 = h2->ProfileX(Form("Prof%s", h.GetName()), -1, 9999, "s");
+    TH1D *h1 = h2->ProfileX(Form("Prof%s", h.GetName()), -1, -1, "s");
     h1->SetDirectory(NULL);
     h1->SetBit(kCanDelete);
@@ -478,5 +478,5 @@
     gPad->SetGridy();
     /*
-    h = fHImpact.ProjectionX("Impact", -1, 9999, "e");
+    h = fHImpact.ProjectionX("Impact", -1, -1, "e");
     h->SetBit(TH1::kNoStats);
     h->SetTitle("Distribution of Impact");
Index: trunk/MagicSoft/Mars/mhflux/MMcSpectrumWeight.cc
===================================================================
--- trunk/MagicSoft/Mars/mhflux/MMcSpectrumWeight.cc	(revision 8680)
+++ trunk/MagicSoft/Mars/mhflux/MMcSpectrumWeight.cc	(revision 8695)
@@ -485,5 +485,5 @@
         *fLog << " New spectral slope:       ";
         if (fNewSlope==-99)
-            *fLog << "undefined" << endl;
+            *fLog << "undefined/no change" << endl;
         else
             *fLog << fNewSlope << endl;